'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.install = install;

var _components2 = require('./components');

var _components = _interopRequireWildcard(_components2);

var _directives2 = require('./directives');

var _directives = _interopRequireWildcard(_directives2);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

// Core Features
function install(Vue) {
    var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    if (install.installed) return;
    install.installed = true;
    var directives = args.directives || _directives;
    var components = args.components || _components;
    for (var name in directives) {
        var directive = directives[name];
        Vue.directive(name, directive);
    }
    (function registerComponents(components) {
        if (components) {
            for (var key in components) {
                var component = components[key];
                if (component && !registerComponents(component.$_vuetify_subcomponents)) {
                    Vue.component(key, component);
                }
            }
            return true;
        }
        return false;
    })(args.components || components);
    Vue.mixin({
        beforeCreate: function beforeCreate() {
            var options = this.$options;
            if (options.vuetify) {
                options.vuetify.init(options.ssrContext);
                this.$vuetify = Vue.observable(options.vuetify.framework);
            } else {
                this.$vuetify = options.parent && options.parent.$vuetify || this;
            }
        }
    });
}
//# sourceMappingURL=install.js.map