// Core Features
import * as _components from './components';
import * as _directives from './directives';
export function install(Vue) {
    var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    if (install.installed) return;
    install.installed = true;
    var directives = args.directives || _directives;
    var components = args.components || _components;
    for (var name in directives) {
        var directive = directives[name];
        Vue.directive(name, directive);
    }
    (function registerComponents(components) {
        if (components) {
            for (var key in components) {
                var component = components[key];
                if (component && !registerComponents(component.$_vuetify_subcomponents)) {
                    Vue.component(key, component);
                }
            }
            return true;
        }
        return false;
    })(args.components || components);
    Vue.mixin({
        beforeCreate: function beforeCreate() {
            var options = this.$options;
            if (options.vuetify) {
                options.vuetify.init(options.ssrContext);
                this.$vuetify = Vue.observable(options.vuetify.framework);
            } else {
                this.$vuetify = options.parent && options.parent.$vuetify || this;
            }
        }
    });
}
//# sourceMappingURL=install.js.map