import Vue from 'vue';
export default Vue.extend({
    name: 'sizeable',
    props: {
        large: Boolean,
        size: {
            type: [Number, String]
        },
        small: Boolean,
        xLarge: Boolean,
        xSmall: Boolean
    },
    computed: {
        medium: function medium() {
            return Boolean(!this.xSmall && !this.small && !this.large && !this.xLarge);
        },
        sizeableClasses: function sizeableClasses() {
            return {
                'v-size--x-small': this.xSmall,
                'v-size--small': this.small,
                'v-size--default': this.medium,
                'v-size--large': this.large,
                'v-size--x-large': this.xLarge
            };
        }
    }
});
//# sourceMappingURL=sizeable.js.map